
-- Provide a type declaration for all defined functions!

-- compute the length of a list of Ints
myLength :: [Int] -> Int
myLength = count' 0
    where count' n [] = n
          count' n (_:lst) = count' (n + 1) lst

-- compute the maximum of a non-empty list of Ints
myMax :: [Int] -> Int
myMax []  = error "max not defined for empty list"
myMax lst = find' (head lst) (tail lst)
    where find' best []       = best
          find' best (x:rest) = find' (if x > best then x else best) rest

-- compute the minimum of a non-empty list of Ints
myMin :: [Int] -> Int
myMin []  = error "min not defined for empty list"
myMin lst = find' (head lst) (tail lst)
    where find' best []       = best
          find' best (x:rest) = find' (if x < best then x else best) rest

-- compute the sum of a non-empty list of Ints
mySum :: [Int] -> Int
mySum = accumulate 0
    where accumulate s [] = s
          accumulate s (x:lst) = accumulate (s + x) lst

-- compute the average of a non-empty list of Ints
myMean :: [Int] -> Double
myMean lst = (fromIntegral $ mySum lst) / (fromIntegral $ myLength lst)


