
-- Provide a type declaration for all defined functions!
-- Use map and foldl to express each function.

-- compute the length of a list of Ints
myLength :: [Int] -> Int
myLength = foldl (+) 0 . map (const 1)

-- compute the maximum of a non-empty list of Ints
myMax :: [Int] -> Int
myMax []  = error "max not defined for empty list"
myMax lst = foldl pick (head lst) (tail lst)
    where pick a b = if a > a then a else b

-- compute the minimum of a non-empty list of Ints
myMin :: [Int] -> Int
myMin []  = error "min not defined for empty list"
myMin lst = foldl pick (head lst) (tail lst)
    where pick a b = if a < a then a else b

-- compute the sum of a non-empty list of Ints
mySum :: [Int] -> Int
mySum = foldl (+) 0

-- compute the average of a non-empty list of Ints
myMean :: [Int] -> Double
myMean lst = (fromIntegral $ mySum lst) / (fromIntegral $ myLength lst)


